<template>
    <div
        class="py-2"
    >
        <mobile-sidebar />
        <div
            class="flex mt-[4.7rem] md:mt-0"
        >
            <pc-sidebar />
            <div class="content">
                <div
                    v-if="$admin"
                    class="top-bar flex justify-between items-center mb-4"
                >
                    <div>
                        <digital-datetime />
                    </div>
                    <div
                        class="dropdown intro-x w-8 h-8 relative"
                        data-tw-placement="bottom-end"
                        @click="dropdownShow = !dropdownShow"
                    >
                        <div class="dropdown-toggle w-8 h-8 rounded-full overflow-hidden shadow-lg image-fit zoom-in" aria-expanded="false" data-tw-toggle="dropdown" role="button">
                            <img
                                :src="'/img/admin.png'"
                            >
                        </div>
                        <div
                            v-if="dropdownShow && $admin"
                            class="dropdown-menu w-56 absolute right-0 top-0 show -translate-x-52 translate-y-8"
                        >
                            <ul class="dropdown-content bg-primary text-white">
                                <li>
                                    <div class="dropdown-header !font-normal">
                                        <div class="font-medium">{{ $admin.username }}</div>
                                        <div class="text-xs text-white/70 mt-0.5 dark:text-slate-500">
                                            <template
                                                v-if="parseInt($admin.type) === 2"
                                            >
                                                Developer
                                            </template>
                                            <template
                                                v-else-if="parseInt($admin.type) === 1"
                                            >
                                                Super Admin
                                            </template>
                                            <template
                                                v-else
                                            >
                                                {{ $admin.group.group_name || '-' }}
                                            </template>
                                        </div>
                                    </div>
                                </li>
                                <li>
                                    <div class="flex justify-center space-x-2 py-2">
                                        <a
                                            v-for="key in Object.keys($helper.getLanguages())"
                                            :key="key"
                                            href="javascript:"
                                            @click="changeLocale($helper.getLanguages()[key])"
                                        >
                                            <img
                                                :src="$helper.getLanguages()[key].flag"
                                                class="h-6"
                                            >
                                        </a>
                                    </div>
                                </li>
                                <li><hr class="dropdown-divider border-white/[0.08]"></li>
                                <li>
                                    <a
                                        class="dropdown-item cursor-pointer hover:bg-white/5"
                                        @click="menuClicked('my_profile')"
                                    >
                                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide w-4 h-4 mr-2"><path d="M20 21v-2a4 4 0 00-4-4H8a4 4 0 00-4 4v2"></path><circle cx="12" cy="7" r="4"></circle></svg>
                                        {{ $t('my_profile') }}
                                    </a>
                                </li>
                                <li>
                                    <hr class="dropdown-divider border-white/[0.08]">
                                </li>
                                <li>
                                    <a
                                        class="dropdown-item cursor-pointer hover:bg-white/5"
                                        @click="logout"
                                    >
                                        <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="lucide w-4 h-4 mr-2"><rect x="1" y="5" width="22" height="14" rx="7" ry="7"></rect><circle cx="16" cy="12" r="3"></circle></svg>
                                        {{ $t('logout')}}
                                    </a>
                                </li>
                            </ul>
                        </div>
                    </div>
                </div>
                <router-view />
                <panel-modal
                    v-if="$admin && profilePopup"
                    :has-footer="false"
                    @close="profilePopup = false"
                >
                    <template #body>
                        <auto-form
                            ref="profileForm"
                            :default-data="{
                                username: $admin.username,
                                name: $admin.name,
                                email: $admin.email,
                            }"
                            :fields="profileFormFields"
                        />
                        <div class="flex justify-end space-x-2">
                            <auto-button
                                type="primary"
                                :block="false"
                                @click="submitProfileForm"
                            >
                                {{ $t('submit') }}
                            </auto-button>
                        </div>
                    </template>
                </panel-modal>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, inject, onBeforeUnmount, onMounted, ref} from "vue";
import EventBus from "!/event-bus.js";
import PanelModal from '~/components/panel-modal.vue';
import AutoForm from "~/components/auto-form.vue";
import {useI18n} from "vue-i18n";
import DigitalDatetime from "~/components/digital-datetime.vue";
import {CONFIG} from "~/config.js";
import AutoButton from "~/components/button/auto-button.vue";
import MobileSidebar from "./sidebar/mobile-sidebar.vue";
import PcSidebar from "./sidebar/pc-sidebar.vue";
import {useLocaleStore} from "~/stores/locale.js";
import {useAdminStore} from "~/stores/admin.js";

const $adminStore = useAdminStore();
const $localeStore = useLocaleStore();
const $i18n = useI18n();
const $helper = inject('$helper');
const $admin = computed(() => $adminStore.account);

const dropdownShow = ref(false);

const profileForm = ref();
const profilePopup = ref(false);

const profileFormFields = computed(() => {
    return [
        {
            type: 'text',
            name: 'username',
            label: $i18n.t('username'),
            readonly: true,
            disabled: true
        },
        {
            type: 'text',
            name: 'name',
            label: $i18n.t('name'),
        },
        {
            type: 'email',
            name: 'email',
            label: $i18n.t('email'),
        },
        {
            type: 'password',
            name: 'new_password',
            label: $i18n.t('new_password'),
            placeholder: $i18n.t('optional'),
            note: $i18n.t('leave_blank_if_not_changing')
        },
        {
            type: 'password',
            name: 'new_password_confirmation',
            label: $i18n.t('new_password_confirmation'),
            placeholder: $i18n.t('optional'),
            note: $i18n.t('leave_blank_if_not_changing')
        },
        {
            type: 'password',
            name: 'current_password',
            label: $i18n.t('current_password'),
        },
    ]
});

const submitProfileForm = async () => {
    try {
        await profileForm.value.submitForm('/profile_submit');

        await $helper.alertSuccess({message: $i18n.t('operation_success'), callback: async () => {
            await $adminStore.fetchAccount();
            profilePopup.value = false;
        }});
    } catch (e) {
        console.log(e);
    }
};

const changeLocale = async (lang) => {
    await $localeStore.updateLocale(lang.locale);
};

const logout = async () => {
    await $adminStore.logoutAccount();
    location.href = CONFIG.APP_ROOT;
};

const menuClicked = async (c) => {
    switch (c) {
        case 'logout': await logout(); break;
        case 'my_profile':
            profilePopup.value = true;
            break;
    }
};

onMounted(() => {
    EventBus.on('MODAL_OPEN', () => {
        document.body.classList.add('modal-open');
    });
    EventBus.on('MODAL_CLOSE', () => {
        document.body.classList.remove('modal-open');
    });
});

onBeforeUnmount(() => {
    EventBus.off('MODAL_OPEN');
    EventBus.off('MODAL_CLOSE');
});
</script>
